Bug 1299179 - Review Request: editorconfig - tools for text editors
Summary: Review Request: editorconfig - tools for text editors
Keywords:
Status: CLOSED DUPLICATE of bug 1573855
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
Andy Lutomirski
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-01-17 02:39 UTC by Dennis Chen
Modified: 2018-10-30 20:19 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-10-30 20:19:05 UTC
Type: ---
luto: fedora-review?


Attachments (Terms of Use)

Description Dennis Chen 2016-01-17 02:39:45 UTC
Spec URL: https://barracks510.fedorapeople.org/packaging/editorconfig.spec
SRPM URL: https://barracks510.fedorapeople.org/packaging/editorconfig-0.12.0-1.fc23.src.rpm
Description: 
EditorConfig makes it easy to maintain the correct coding style when switching
between different text editors and between different projects. The EditorConfig
project maintains a file format and plugins for various text editors which
allow this file format to be read and used by those editors. For information on
the file format and supported text editors, see the EditorConfig website.
Fedora Account System Username: barracks510

Koji Build Link: https://koji.fedoraproject.org/koji/taskinfo?taskID=12584281

Comment 1 Andy Lutomirski 2016-01-21 18:25:12 UTC
Given that you're packaged editorconfig-devel, can you split out editorconfig-libs?  That way the 32-bit version will be installable on 64-bit machines.

editorconfig-doc should either include the license or should require something that does.

Comment 3 Upstream Release Monitoring 2016-01-26 05:51:37 UTC
barracks510's scratch build of editorconfig-0.12.0-2.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12685907

Comment 4 Andy Lutomirski 2016-02-05 20:39:37 UTC
Comments:

You have the ldconfig scriptlets attached to the wrong package -- they belong on -libs.

This is wrong:

%package -n %{name}-libs
Summary:	Shared libraries for EditorConfig
Group:		Documentation
Requires:	%{name}%{?_isa} = %{version}-%{release}

The main package should require the -libs package (which rpm will do for you by figuring it out from DT_NEEDED), not the other way around.  In particular, your current variant breaks multilib installs.

If you fix that, please move the %license to -libs.  You may need it in -doc, too.

fedora-review is chugging away at this, and I may have more comments when it finishes.

Comment 5 Andy Lutomirski 2016-02-08 22:36:44 UTC
There's a bunch of stuff here.  Please re-run fedora-review yourself when you update the package.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Development (unversioned) .so files in -devel subpackage, if present.
  Note: Unversioned so-files directly in %_libdir.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages

Somehow libeditorconfig.so ended up in -libs and in -devel.  I think
it's a result of %{_libdir}/* in the %files -n %{name}-libs section.

- ldconfig called in %post and %postun if required.
  Note: /sbin/ldconfig not called in editorconfig-libs
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Shared_Libraries


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "BSD (2 clause)", "Unknown or generated",
     "BSD". 4 files have unknown license. Detailed output of licensecheck
     in /home/luto/devel/fedora/editorconfig/editorconfig/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[?]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.

Requires: pcre should not be needed.  rpm figured out:

    libpcre.so.1()(64bit)

for you.

[s]: Spec file is legible and written in American English.
[s]: Package contains systemd file(s) if in need.
[s]: Useful -debuginfo package or justification otherwise.
[s]: Package is not known to require an ExcludeArch tag.
[s]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 491520 bytes in 71 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     editorconfig-debuginfo
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[!]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[?]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 1003520 bytes in /usr/share

Can you make the -doc package noarch?  If not, it's not the end of the world.

[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: editorconfig-0.12.0-2.fc21.x86_64.rpm
          editorconfig-devel-0.12.0-2.fc21.x86_64.rpm
          editorconfig-doc-0.12.0-2.fc21.x86_64.rpm
          editorconfig-libs-0.12.0-2.fc21.x86_64.rpm
          editorconfig-debuginfo-0.12.0-2.fc21.x86_64.rpm
          editorconfig-0.12.0-2.fc21.src.rpm
editorconfig.x86_64: W: shared-lib-calls-exit /usr/lib64/libeditorconfig.so.0.12.0 exit@GLIBC_2.2.5
editorconfig-devel.x86_64: W: only-non-binary-in-usr-lib
editorconfig-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libeditorconfig.so.0.12.0 exit@GLIBC_2.2.5
editorconfig-libs.x86_64: W: no-documentation
editorconfig-libs.x86_64: E: library-without-ldconfig-postin /usr/lib64/libeditorconfig.so.0.12.0
editorconfig-libs.x86_64: E: library-without-ldconfig-postun /usr/lib64/libeditorconfig.so.0.12.0
editorconfig-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libeditorconfig.so
6 packages and 0 specfiles checked; 2 errors, 5 warnings.




Rpmlint (debuginfo)
-------------------
Checking: editorconfig-debuginfo-0.12.0-2.fc21.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
editorconfig-devel.x86_64: W: only-non-binary-in-usr-lib
editorconfig-libs.x86_64: W: shared-lib-calls-exit /usr/lib64/libeditorconfig.so.0.12.0 exit@GLIBC_2.2.5
editorconfig-libs.x86_64: W: no-documentation
editorconfig-libs.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libeditorconfig.so
editorconfig-libs.x86_64: E: library-without-ldconfig-postin /usr/lib64/libeditorconfig.so.0.12.0
editorconfig-libs.x86_64: E: library-without-ldconfig-postun /usr/lib64/libeditorconfig.so.0.12.0
editorconfig.x86_64: W: shared-lib-calls-exit /usr/lib64/libeditorconfig.so.0.12.0 exit@GLIBC_2.2.5
5 packages and 0 specfiles checked; 2 errors, 5 warnings.



Requires
--------
editorconfig-debuginfo (rpmlib, GLIBC filtered):

editorconfig-devel (rpmlib, GLIBC filtered):
    editorconfig(x86-64)
    libeditorconfig.so.0()(64bit)

editorconfig-libs (rpmlib, GLIBC filtered):
    editorconfig(x86-64)
    libc.so.6()(64bit)
    libeditorconfig.so.0()(64bit)
    libpcre.so.1()(64bit)
    rtld(GNU_HASH)

editorconfig-doc (rpmlib, GLIBC filtered):
    editorconfig(x86-64)

editorconfig (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libpcre.so.1()(64bit)
    pcre
    rtld(GNU_HASH)



Provides
--------
editorconfig-debuginfo:
    editorconfig-debuginfo
    editorconfig-debuginfo(x86-64)

editorconfig-devel:
    editorconfig-devel
    editorconfig-devel(x86-64)

editorconfig-libs:
    editorconfig-libs
    editorconfig-libs(x86-64)
    libeditorconfig.so.0()(64bit)

editorconfig-doc:
    editorconfig-doc
    editorconfig-doc(x86-64)

editorconfig:
    editorconfig
    editorconfig(x86-64)
    libeditorconfig.so.0()(64bit)



Unversioned so-files
--------------------
editorconfig-libs: /usr/lib64/libeditorconfig.so

Source checksums
----------------
https://github.com/editorconfig/editorconfig-core-c/archive/v0.12.0.tar.gz#/editorconfig-0.12.0.tar.gz :
  CHECKSUM(SHA256) this package     : a53b67aca5ba307c37e9e002fa6cc5e5399ac0099eaeeca700ad703ee6e5278b
  CHECKSUM(SHA256) upstream package : a53b67aca5ba307c37e9e002fa6cc5e5399ac0099eaeeca700ad703ee6e5278b


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -rn editorconfig-0.12.0-2.fc23.src.rpm
Buildroot used: fedora-21-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 6 Dennis Chen 2016-03-15 01:14:12 UTC
Ok. This time I've double checked with Fedora-Review to make sure there are no more issues. 

SRPM: https://barracks510.fedorapeople.org/packaging/editorconfig-0.12.0-3.fc23.src.rpm
SPEC: https://barracks510.fedorapeople.org/packaging/editorconfig.spec

Comment 7 Andy Lutomirski 2016-03-18 02:15:05 UTC
Still multiple issues.

editorconfig-libs and editorconfig-doc both unnecessarily depend on editorconfig.  These are both serious problems -- the former will break multilib and the latter will fail to install on anything except whatever architecture happened to build it in koji.  Once these are fixed, they'll need %license directives.

editorconfig-libs curiously does *not* depend on libeditorconfig.  That's because it was built wrong:

/usr/bin/cc  -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 
-fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-swi
tches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic    -Wl,
-z,relro -specs=/usr/lib/rpm/redhat/redhat-hardened-ld CMakeFiles/editorconfig_b
in.dir/main.c.o  -o ../../bin/editorconfig-0.12.0 -rdynamic ../../lib/libeditorc
onfig_static.a -lpcre

To fix that, you'll either need to patch the cmake rules or fix the build options to get it to link against the shared library.

Once you fix *that*, the %license directive in the main package can optionally go away.

Comment 9 David Demelier 2018-01-19 13:49:53 UTC
Any news on this package? I would like to have it as well and the proposed one is better than mine :)

Comment 10 Robert-André Mauchin 🐧 2018-01-19 23:54:23 UTC
Are you still interested in this package, Dennis Chen? Latest version is 0.12.1. If you update your SPEC, I'll continue the review.

Comment 11 Dennis Chen 2018-10-30 20:19:05 UTC

*** This bug has been marked as a duplicate of bug 1573855 ***


Note You need to log in before you can comment on or make changes to this bug.